/*
Exploring Arduino - Code Listing 3-1: Potentiometer Reading Sketch
http://www.exploringarduino.com/content/ch3

Copyright 2013 Jeremy Blum ( http://www.jeremyblum.com )
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License v3 as published by
the Free Software Foundation.
*/

// Temperature serial read program TMP36 sensor

const int GLED = 9; // sets green led to pin 9
const int RLED = 10; // sets red led to pin 10
const int BLED = 11; // sets blue led to pin 11
const float OFFSET = 5.0; // temperature conversion offset if needed
const int MIN_LEVEL = 100;
const int MAX_LEVEL = 200;
const float LOWER_LIMIT = 21.5; //lower temp limit in Centigrade
const float UPPER_LIMIT = 22.5; //upper limit in Centigrade
const int TEMP = 0;  // sets analog pin for temperature read
int level = 0;        // sets initial value of read variable to 0
int alevel = 0;       // set default analog level if needed
float calctemp = 0.0; // calculated temperature from TMP36
float mVout = 700.0;  // holds converted ADC (analog) value from TMP36 into mV

void setup() {
  
  Serial.begin(9600);           // initializes serial terminal to monitor output
  pinMode(RLED,OUTPUT);         // set output pins
  pinMode(GLED,OUTPUT);
  pinMode(BLED,OUTPUT);
  digitalWrite(RLED,HIGH);      // initialize all LED's off (HIGH due to common anode
  digitalWrite(GLED,HIGH);      //   on my RGB LED - common cathode LED's would be LOW)
  digitalWrite(BLED,HIGH);

}

void loop() {
  
  
/*  Test loop to verify pin assigments for LED's
  digitalWrite(RLED,LOW);
  delay(500);
    digitalWrite(RLED,HIGH);
  digitalWrite(GLED,LOW);
  delay(500);
    digitalWrite(GLED,HIGH);
  digitalWrite(BLED,LOW);
  delay(500);
    digitalWrite(BLED,HIGH);
*/

   level = analogRead(TEMP);
//   alevel = map(level,MIN_LEVEL,MAX_LEVEL,255,0);  // not needed for this sketch
   mVout = (((float)level)/1023)*5000;           // this converts the analog reading to mV
   calctemp=(mVout-500)/10;                      // calculates temp from mV according to datasheet
    Serial.print("level: ");                     // output data to monitor
    Serial.print(level);
    Serial.print(" TMP36 output mV: ");
    Serial.print(mVout);
    Serial.print(" Calculated Temp: ");
    Serial.println(calctemp);
    
    if (calctemp < LOWER_LIMIT)                  // set correct LED
    {  digitalWrite(BLED,LOW);
       digitalWrite(GLED,HIGH);
    }
    else if (calctemp > UPPER_LIMIT)
    {  digitalWrite(RLED,LOW);
       digitalWrite(GLED,HIGH);
    }
    else 
    {  digitalWrite(RLED,HIGH);
       digitalWrite(BLED,HIGH);
       analogWrite(GLED,alevel);
    }
    delay(1500);


}
